#include <iostream>
#include <random>
#include <vector>

#include "icpc_gen_helper.h"
using namespace icpc_gen_helper;
typedef long long ll;
using namespace std;

constexpr ll MAX1 = 1000000;
constexpr ll MAX2 = 1000;

int main(int argc, char** argv){
	Init(argc, argv);
	const ll n = stoll(getParam("--cylinders"));
	
	const ll extreme = (discrete_distribution<int>{1,4,1})(rng);
	
	const ll v = [&] {
			if (extreme == 0)
				return max(1ll, (geometric_distribution<ll>(0.1))(rng));
			else if (extreme == 2)
				return MAX1 - (geometric_distribution<int>(0.1))(rng);
			else
				return uniform_number(1ll, MAX1);
		}();

	const bool impossible = v > 1 && 0 == uniform_number(0, 4); // 20% chance of impossible

	vector<pair<ll,ll>> data;

	assert(n <= MAX1 && v <= MAX1);
	for (ll i = 0; i < n; i++) {
		ll r,h;
		if (impossible || i * 2 >= n) {
			h = uniform_number(1ll, (ll)((v-1)/M_PI));
			r = max(1ll, ((ll) sqrt(v / (M_PI * h))) - (geometric_distribution<ll>(0.01))(rng));
			while (h*r*r * M_PI >= v) {
				((uniform_number(0,1) && h > 1 || r <= 1) ? h : r)--;
			}
			if (!impossible) {
				h += uniform_number(-10ll, 10ll);
				r += uniform_number(-10ll, 10ll);
			}
			h = max(1ll, min(h, MAX2));
			r = max(1ll, min(r, MAX2));
			assert(!impossible || h*r*r*M_PI < v);
		} else {
			r = uniform_number(1ll, MAX2);
			h = uniform_number(1ll, MAX2);
		}
		data.emplace_back(h, r);
	}

	shuffle(data.begin(), data.end(), rng);

	/////////////////////////////////////

	assert(1 <= v && v <= MAX1);
	cout << n << " " << v << endl;
	for (auto[h,r] : data) {
		assert(1 <= h && h <= MAX2);
		assert(1 <= r && r <= MAX2);
		assert(!impossible || h*r*r*M_PI < v);
		cout << h << " " << r << '\n';
	}
	return 0;
}
