#include "icpc_gen_graph.h"
#include "icpc_gen_helper.h"
#include <bits/stdc++.h>

using namespace icpc_gen_helper;
using namespace icpc_gen_graph;
using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define sz(x) (ll)(x).size()

int main(int argc, char** argv) {
	Init(argc, argv);

	ll n = std::stoull(getParam("--n"));
	ll k = std::stoull(getParam("--k"));
	ld p = std::stold(getParam("--p"));
	
	ll rem = n;
	vector<ll> sz;
	std::uniform_int_distribution<> distr(1, n-1);
	for(int i = 0;  i < k -1; ++i) {
	    sz.push_back(distr(rng));
	}
	sz.push_back(n);
	std::sort(sz.begin(), sz.end());

	Graph g = randomGraph(sz[0], p, rng).setOffset(1).permutate(rng);
	for(int i = 1; i < k; ++i) {
	    Graph g2 = randomGraph(sz[i] - sz[i-1], p, rng).setOffset(1).permutate(rng);
	    g.append(g2);	
	}
	cout << g.nodeCount() << " " << g.edgeCount() << endl;
	for (auto e : g.getEdges()) {
		cout << e.from << " " << e.to << endl;
	}
}
