#undef NDEBUG

#include <cassert>
#include <iostream>

using namespace std;

using ll = long long;

const ll MAXN = 1000000;

void validate(string_view& s) {
	assert(s[0] == '(');
	if (s[1] == ')') {
		s = s.substr(2);
		return;
	}
	validate(s = s.substr(1));
	const char op = s[0];
	assert(op == '*' || op == '+');
	validate(s = s.substr(1));
	assert(s[0] == ')');
	s = s.substr(1);
}

int main() {
	ios::sync_with_stdio(0), cin.tie(0);

	string s;
	cin >> s;

	assert(s.length() <= MAXN);

	string_view s_ = s;
	validate(s_);
	assert(s_.empty());
	return 42;
}
