#!/usr/bin/env python3

n, m = map(int, input().split())

par = list(range(n))
vcount = [1] * n
ecount = [0] * n

def root(i):
    j = i
    while par[j] != j:
        j = par[j]
    par[i] = j
    return par[i]

def unite(i, j):
    i, j = root(i), root(j)
    if i == j:
        ecount[j] += 1
        return
    if vcount[i] > vcount[j]:
        i, j = j, i
    par[i] = j
    vcount[j] += vcount[i]
    ecount[j] += ecount[i] + 1

for _ in range(m):
    a, b = map(int, input().split())
    unite(a-1, b-1)

res = 0
for i in range(n):
    if root(i) == i:
        res += vcount[i]*(vcount[i]-1)//2 - ecount[i]
print(res)
