#include <bits/stdc++.h>
using namespace std;

const double eps = 1e-9;

struct point { double x, y; };

point  operator+(point a,  point b) { return {a.x+b.x, a.y+b.y}; }
point  operator-(point a,  point b) { return {a.x-b.x, a.y-b.y}; }
point  operator*(double t, point b) { return {t*b.x, t*b.y}; }
double operator*(point a,  point b) { return a.x*b.x + a.y*b.y; } // dot product

double abs(point a) { return hypot(a.x,a.y); }
point perp(point a) { return {-a.y,a.x}; } // rotate 90 degrees counterclockwise

void intersectCC(point a, double r, point b, double s, vector<point> &res) {
    double d = abs(b-a);
    if (d > r+s+eps) return; // disjoint
    if (d < abs(r-s)-eps) return; // inside
    if (d < eps && abs(r-s) < eps) return; // same

    double x = (d*d + r*r - s*s) / (2*d), y = sqrt(abs(r*r - x*x));
	x /= d, y /= d;
    res.push_back(a + x*(b-a) + y*perp(b-a));
	if (abs(y) > eps) res.push_back(a + x*(b-a) - y*perp(b-a));
}

int main() {
	int n, k;
	cin >> n >> k;

	if (k > n*(n-1)) {
		cout << "impossible" << endl;
		return 0;
	}

	vector<point> a(n);
	vector<int> r(n, 1);
	for (int i = 0; i < n; i++) {
		a[i].x = 10 * (i%3);
		a[i].y = 10 * (i/3);
	}
	
	auto intersection_count = [&]() {
		vector<point> v;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < i; j++) {
				intersectCC(a[i], r[i], a[j], r[j], v);
			}
		}

		auto cmp = [](point a, point b) {
			if (abs(a.x-b.x) > eps) return a.x < b.x;
			return a.y+eps < b.y;
		};
		set<point,decltype(cmp)> s(begin(v), end(v));
		return ssize(s);
	};

	for (int t = 0; ; t++) {
		int m = intersection_count();
		if (m == k) {
			for (int i = 0; i < n; i++) {
				cout << a[i].x << " " << a[i].y << " " << r[i] << endl;
			}
			break;
		}

		int i = t % n;
		if (m < k) {
			if (r[i] < 1000) r[i]++;
		} else {
			if (r[i] > 1) r[i]--;
		}
	}
}
