import java.util.*;

public class PaulDirectedEdges {
	class Node {
		int id;
		boolean visited = false;
		int vertexCount = 1;
		int edgeCount = 0;
		List<Node> neighbors;

		public Node(int id) {
			this.id = id;
			neighbors = new ArrayList<Node>();
		}
		
		void dfs() {
			visited = true;
			for (Node n: neighbors) {
				edgeCount += id < n.id ? 1 : 0;
				if (n.visited) continue;
				n.dfs();
				vertexCount += n.vertexCount;
				edgeCount += n.edgeCount;
			}
		}
	};

	void run() {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int m = sc.nextInt();

		Node[] nodes = new Node[n];
		for (int i = 0; i < n; i++) {
			nodes[i] = new Node(i);
		}

		for (int i = 0; i < m; i++) {
			int a = sc.nextInt() - 1;
			int b = sc.nextInt() - 1;
			nodes[a].neighbors.add(nodes[b]);
			// nodes[b].neighbors.add(nodes[a]); oops!
		}

		long res = 0;
		for (int i = 0; i < n; i++) {
			if (nodes[i].visited) continue;
			nodes[i].dfs();
			res += (long) nodes[i].vertexCount * (nodes[i].vertexCount - 1) / 2;
			res -= nodes[i].edgeCount;
		}
		System.out.println(res);
	}
	
	public static void main(String[] args) {
		new PaulDirectedEdges().run();
	}
}
